



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java_Object</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java_Object</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 17:58:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>说一下java中的Object类。</p>
<p><strong>1、Object：</strong></p>
<p>Object是java类库中的一个特殊类，也是所有类的父类。</p>
<p>Object类定义了一些有用的方法，由于是根类，这些方法在其他类中都存在，一般是进行了重载或重写，实现了各自的具体功能。</p>
<p><strong>1.1、Object中的equals()方法：</strong></p>
<p>讲到equals()方法 我们先看下 "==" 与 equals()的区别：</p>
<p>==是一个比较运算符，对于基本数据类型来说，比较的是值；引用数据类型比较的是地址值(指是否为同一个对象的引用)(除非是同一个new出来的对象，==比较结果为true，否则均为false)。</p>
<p>equals()是一个方法，只能比较引用数据类型。重写前比较的是地址值，重写后一般是比较对象的属性。</p>
<p><strong>1.2、为什么要重写equals()方法？</strong></p>
<p>Object类中的equals()方法比较的是两个对象的内存地址，对象之间比较内存地址一般是没有意义的，所以我们一般会重写equals()方法。</p>
<p>举个栗子：</p>
<p>我们定义了一个学生类，学生的属性为id和name，我们认为id和name都相同的情况下，他们的equals是true。但是当我们执行代码 控制台输出的却是false。不符合我们的需求，我们需要重写equals()方法。</p>
<div>
<pre class="prettyprint linenums">public class Student {<br />
	public Integer id;<br />
	public String name;

	public Student(Integer id,String name){<br />
		this.id = id;<br />
		this.name = name;<br />
	}

	public static void main(String[] args) {<br />
		Student s1 = new Student(1,"Rain");<br />
		Student s2 = new Student(1,"Rain");

		System.out.println(s1.equals(s2));<br />
	}<br />
}
</pre>
</div>
<p><strong>1.3、如何重写equals()方法？</strong></p>
<p><strong>原则：</strong></p>
<p>1）自反性：对于任何非空引用X，X.equals(X)应该为true；</p>
<p>2）对称性：对于任何引用X和Y，如果X.equals(Y)返回true，那么Y.equals(X)也应该返回true；</p>
<p>3）传递性：对于任何引用X，Y，Z，如果X.equals(Y)返回true，Y.equals(Z)返回true，那么X.equals(Z)也应该返回true；</p>
<p>4）一致性：如果X和Y引用的对象没有发生变化，那么反复调用X.equals(Y)应该返回相同的结果；</p>
<p>5）非空性：对于任意非空引用X，X.equals(null)应该返回false。</p>
<p>一个栗子：</p>
<div>
<pre class="prettyprint linenums">public class Coder {<br />
	public String name;<br />
	public int age;

	public Coder(){}<br />
	public Coder(String name,int age){<br />
		this.name = name;<br />
		this.age = age;<br />
	}

	public static void main(String[] args) {<br />
		Coder c1 = new Coder("R",26);<br />
		Coder c2 = new Coder("R",26);<br />
		System.out.println(c1.equals(c2));<br />
	}

	public boolean equals(Object obj){<br />
		//判断是否为同一对象<br />
		if(this == obj){<br />
			return true;<br />
		}<br />
		//判断是否为null<br />
		if(null == obj){<br />
			return false;<br />
		}<br />
		//判断两者类型<br />
		if(this.getClass() != obj.getClass()){<br />
			return false;<br />
		}<br />
		//类型转换<br />
		Coder coder = (Coder) obj;<br />
		//判断数据<br />
		if(this.name.equals(coder.name) &amp;&amp; this.age == coder.age){<br />
			return true;<br />
		}<br />
		return false;<br />
	}<br />
}
</pre>
</div>
<p>因为重写了equals()方法，控制台输出：true</p>
<p><strong>2.1、Object中的hashCode()方法：</strong></p>
<p>在java中，如果我们重写了equals()方法，那么必定要重写hashCode()方法。why？</p>
<p>首先我们需要知道hashCode的作用。java中hashCode的主要作用是 用增加哈希存储结构（HashMap，HashTable之类）的查找速度，这些哈希存储结构可以通过hashCode来确定对象在哈希存储结构中的存储位置。通过这句描述我们知道：</p>
<p>1）hashCode主要作用在于增加数据在哈希家族中的查找速度；</p>
<p>2）如果hashCode相等，它们在哈希结构中存储位置相等，但是不是同一个对象。换句话说，hashCode相等，调用equals不一定相等；</p>
<p>3）如果equals相等，那么它们的存储位置当然相等，所以hashCode一定是相等的；</p>
<p>那么为什么必须要重写hashCode()方法呢？简单来说，就是为了保证同一个对象，在equals相同的情况下hashCode值必定相同，如果重写了equals()方法而未重写hashCode()方法，可能就会出现两个没有关系的对象equals相同(因为equals都是根据对象的特征进行重写的)，但hashCode不同。</p>
<p>一个栗子：</p>
<div>
<pre class="prettyprint linenums">//重写hashCode()<br />
public int hashCode(){<br />
	final int prime = 31;  //为什么是31？因为这个数需要是质数 31是经 验证的一个能够很好的减少哈希碰撞的质数<br />
	int result = 1;<br />
	result = prime * result + age;<br />
	result = prime * result + ((name == null)?0:name.hashCode());<br />
	return result;<br />
}
</pre>
</div>
<p><strong>3.1、Object中的getClass()方法：</strong></p>
<p>getClass()方法返回对象所属的类，是一个class对象。通过Class对象可以获取该类的各种信息，包括类名、父类以及它所实现的接口名称。</p>
<p>一个栗子：</p>
<div>
<pre class="prettyprint linenums">public class Test02 {<br />
	public static void printClassInfo(Object obj){<br />
		System.out.println("类名："+obj.getClass().getName());

		System.out.println("父类："+obj.getClass().getSuperclass().getName());

		for(int i=0;i&lt;obj.getClass().getInterfaces().length;i++){<br />
			System.out.println("实现的接口："+obj.getClass().getInterfaces()[i]);<br />
		}<br />
	}

	public static void main(String[] args) {<br />
		String strobj = new String();<br />
		printClassInfo(strobj);<br />
	}<br />
}
</pre>
</div>
<p>控制台输出：</p>
<div>
<pre class="prettyprint linenums">类名：java.lang.String<br />
父类：java.lang.Object<br />
实现的接口：interface java.io.Serializable<br />
实现的接口：interface java.lang.Comparable<br />
实现的接口：interface java.lang.CharSequence
</pre>
</div>
<p>OK，Object类的方法就介绍以上三个。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495xn7v8.html">UEFI&plus;GPT安装windows</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn1ekx8.html">shell命令find</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ejpxj9.html">java 无符号byte转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jxpneq.html">W3School-CSS 边框&lpar;border&rpar;实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn6ekg9.html">HTML &amp;lt&semi;&excl;DOCTYPE&amp;gt&semi; 标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/390g4548.html">Codeforces Round &num;381 &lpar;Div&period; 1&rpar; A&period; Alyona and mex 构造</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k7ew39.html">用Razor語法寫範本-RazorEngine組件介紹【转&mdash;&mdash;非常好，可以用它来代替NVelocity】</a>
		</li>
						<li><a href="https://www.batexi.com/a/4956wvv8.html">js  函数声明方式以及javascript的历史</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wkjjwq.html">&lbrack;drp 7&rsqb;转发和重定向的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmny1x9.html">VS2013 安装phonegap</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmd5ol9.html">仿jQuery中undelegate&lpar;&rpar;方法功能的函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1p5rv9.html">【技术贴】解决xp下Microsoft&period;SqlServer&period;Management&period;PSProvider&period;dll</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1xj369.html">OC教程10-NSNumber具体</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mvkxn8.html">js 常用正则表达式分析详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj35vg8.html">Go语言中的Iota</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvrpky8.html">Python随机字符串验证码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll31n0q.html">Django中的View视图讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m25rzrq.html">Python操作MySql --Python3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv2m0r8.html">芯灵思SinlinxA33开发板Linux内核定时器编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kd3lwq.html">&lbrack;Usaco2009 Feb&rsqb;Revamping Trails 道路升级 BZOJ1579</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90m6v448.html">&lbrack;经验交流&rsqb; kubeadm 安装 kubernetes 一年过期的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me1egpq.html">python中的operator&period;itemgetter函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz5zkl8.html">Python&mdash;&mdash;类的封装</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo0omdq.html">java学习笔记08-switch case语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m6r148.html">Andriod studio 目录结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zkl7x9.html">Django 之 路由URL，视图，模板，ORM操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdlkvy9.html">python读取uti-8格式ini配置文件出现UnicodeDecodeError&colon; &amp;&num;39&semi;gbk&amp;&num;39&semi; codec can&amp;&num;39&semi;t decode byte 0xba in position 367&colon; illegal multibyte sequence错误解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jpmlw8.html">js &amp;amp&semi;运算符什么意思，什么用处</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz52je8.html">window10 蓝牙只能发不能收文件解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjpylx8.html">C&num;应用编程小例子-02-窗体最大化和最小化窗体大小</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
